/**
***     Copyright (C) 2003 SophiaCradle, Inc.
***     All rights reserved.
**/

#include "AEEModGen.h"      // W[ C^[tF[X̐錾
#include "AEEAppGen.h"      // Avbg C^[tF[X̐錾
#include "AEEGraphics.h"    // IGraphics C^[tF[X̐錾
#include "AEETransform.h"   // ITransform C^[tF[X̐錾
#include "graphix.bid"      // NX ID t@C̃CN[h
#include "graphix_res.h"    // \[X`t@C̃CN[h

// graphix Avbg\
typedef struct GraphixApplet {
    AEEApplet       a;      // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱
    IGraphics*      g;      // IGraphics IuWFNg
} GraphixApplet;

// O錾
        int         AEEClsCreateInstance(AEECLSID,IShell*,IModule*,void**);
static  boolean     Graphix_HandleEvent(GraphixApplet*,AEEEvent,uint16,uint32);
static  boolean     Graphix_OnAppStart(GraphixApplet*);
static  boolean     Graphix_OnAppStop(GraphixApplet*);
static  boolean     Graphix_OnAppResume(GraphixApplet*);
static  boolean     Graphix_OnAppSuspend(GraphixApplet*);
static  boolean     Graphix_OnAppKey(GraphixApplet*,uint16);
static  void        Graphix_ClipRectUseIGraphics(GraphixApplet*);
static  void        Graphix_ClipCircleUseIGraphics(GraphixApplet*);
static  void        Graphix_ClipRectUseIDisplay(GraphixApplet*);
static  void        Graphix_UseIGraphicsAndIDisplay(GraphixApplet*);
static  void        Graphix_TranslateUseIGraphics(GraphixApplet*);
static  void        Graphix_TransformSimple(GraphixApplet*);
static  void        Graphix_TransformComplex(GraphixApplet*);
static  void        Graphix_ClearScreen(GraphixApplet*);

//
//  Avbg쐬ƂɌĂяo܂
//
int AEEClsCreateInstance(AEECLSID id,IShell* shell,IModule* module,void** applet)
{
    *applet = NULL;
    if (id == AEECLSID_GRAPHIX) {
        if (AEEApplet_New(sizeof(GraphixApplet),id,shell,module,
                          (IApplet**)applet,(AEEHANDLER)Graphix_HandleEvent,NULL)) {
            return(SUCCESS);
        }
    }
    return(EFAILED);
}

//
//  Cxg nh
//
static boolean Graphix_HandleEvent(GraphixApplet* app,AEEEvent event,uint16 p16,uint32 p32)
{
    switch (event) {
        case EVT_APP_START:
            return Graphix_OnAppStart(app);

        case EVT_APP_STOP:
            return Graphix_OnAppStop(app);

        case EVT_APP_RESUME:
            return Graphix_OnAppResume(app);

        case EVT_APP_SUSPEND:
            return Graphix_OnAppSuspend(app);

        case EVT_KEY:
            return Graphix_OnAppKey(app,p16);

        default:
            break;
    }
    return(FALSE);
}

//
//  AvbgJnƂɌĂяo
//
static boolean Graphix_OnAppStart(GraphixApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;

    // IGraphics IuWFNg̍쐬
    ISHELL_CreateInstance(shell,AEECLSID_GRAPHICS,&app->g);

    // ʂԂɐݒ
    Graphix_ClearScreen(app);
    return(TRUE);
}

//
//  AvbgIƂɌĂяo
//
static boolean Graphix_OnAppStop(GraphixApplet* app)
{
    IGraphics*      graphics    = app->g;

    // IGraphics IuWFNg̔j
    IGRAPHICS_Release(graphics);
    return(TRUE);
}

//
//  AvbgĊJƂɌĂяo
//
static boolean Graphix_OnAppResume(GraphixApplet* app)
{
    // ʂԂɐݒ
    Graphix_ClearScreen(app);
    return(TRUE);
}

//
//  AvbgfƂɌĂяo
//
static boolean Graphix_OnAppSuspend(GraphixApplet* app)
{
    return(TRUE);
}

//
//  L[ꂽƂɌĂяo
//
static boolean Graphix_OnAppKey(GraphixApplet* app,uint16 key)
{
    switch (key) {
        case AVK_0:
            Graphix_ClearScreen(app);
            return(TRUE);

        case AVK_1:
            Graphix_ClipRectUseIGraphics(app);
            return(TRUE);

        case AVK_2:
            Graphix_ClipCircleUseIGraphics(app);
            return(TRUE);

        case AVK_3:
            Graphix_ClipRectUseIDisplay(app);
            return(TRUE);

        case AVK_4:
            Graphix_UseIGraphicsAndIDisplay(app);
            return(TRUE);

        case AVK_5:
            Graphix_TranslateUseIGraphics(app);
            return(TRUE);

        case AVK_6:
            Graphix_TransformSimple(app);
            return(TRUE);

        case AVK_7:
            Graphix_TransformComplex(app);
            return(TRUE);

        default:
            break;
    }
    return(FALSE);
}

//
//  IGraphics C^[tF[Xgpċ`̈
//  NbsOĕ`悷֐
//
static void Graphix_ClipRectUseIGraphics(GraphixApplet* app)
{
    IGraphics*      graphics    = app->g;
    AEEClip         clip;
    AEERect         rect;
    AEECircle       circle;

    // ʂΐFŃNA
    IGRAPHICS_SetBackground(graphics,0xCC,0xFF,0xCC);
    IGRAPHICS_ClearViewport(graphics);

    // NbsÖlp`ɐݒ
    clip.type = CLIPPING_RECT;
    clip.shape.rect.x = 20;
    clip.shape.rect.y = 20;
    clip.shape.rect.dx = 80;
    clip.shape.rect.dy = 80;
    IGRAPHICS_SetClip(graphics,&clip,0);

    // hׂ[hݒ
    IGRAPHICS_SetFillMode(graphics,TRUE);

    // `FԐFɐݒ
    IGRAPHICS_SetColor(graphics,0xFF,0x88,0x88,0x00);
    IGRAPHICS_SetFillColor(graphics,0xFF,0xCC,0xCC,0x00);

    // lp``
    rect.x = 10;
    rect.y = 10;
    rect.dx = 60;
    rect.dy = 50;
    IGRAPHICS_DrawRect(graphics,&rect);

    // `FFɐݒ
    IGRAPHICS_SetColor(graphics,0x88,0x88,0xFF,0x00);
    IGRAPHICS_SetFillColor(graphics,0xCC,0xCC,0xFF,0x00);

    // ~`
    circle.cx = 80;
    circle.cy = 70;
    circle.r = 40;
    IGRAPHICS_DrawCircle(graphics,&circle);

    // NbsÖZbg
    IGRAPHICS_SetClip(graphics,NULL,0);

    // ʍXV
    IGRAPHICS_Update(graphics);
    return;
}

//
//  IGraphics C^[tF[Xgpĉ~̈
//  NbsOĕ`悷֐
//
static void Graphix_ClipCircleUseIGraphics(GraphixApplet* app)
{
    IGraphics*      graphics    = app->g;
    AEEClip         clip;
    AEERect         rect;
    AEECircle       circle;

    // ʂΐFŃNA
    IGRAPHICS_SetBackground(graphics,0xCC,0xFF,0xCC);
    IGRAPHICS_ClearViewport(graphics);

    // NbsÖ~ɐݒ
    clip.type = CLIPPING_CIRCLE;
    clip.shape.circle.cx = 60;
    clip.shape.circle.cy = 60;
    clip.shape.circle.r = 40;
    IGRAPHICS_SetClip(graphics,&clip,0);

    // hׂ[hݒ
    IGRAPHICS_SetFillMode(graphics,TRUE);

    // `FԐFɐݒ
    IGRAPHICS_SetColor(graphics,0xFF,0x88,0x88,0x00);
    IGRAPHICS_SetFillColor(graphics,0xFF,0xCC,0xCC,0x00);

    // lp``
    rect.x = 10;
    rect.y = 10;
    rect.dx = 60;
    rect.dy = 50;
    IGRAPHICS_DrawRect(graphics,&rect);

    // `FFɐݒ
    IGRAPHICS_SetColor(graphics,0x88,0x88,0xFF,0x00);
    IGRAPHICS_SetFillColor(graphics,0xCC,0xCC,0xFF,0x00);

    // ~`
    circle.cx = 80;
    circle.cy = 70;
    circle.r = 40;
    IGRAPHICS_DrawCircle(graphics,&circle);

    // NbsÖZbg
    IGRAPHICS_SetClip(graphics,NULL,0);

    // ʍXV
    IGRAPHICS_Update(graphics);
    return;
}

//
//  IDisplay C^[tF[Xgpċ`̈
//  NbsOĕ`悷֐
//
static void Graphix_ClipRectUseIDisplay(GraphixApplet* app)
{
    IDisplay*       display     = app->a.m_pIDisplay;
    AEERect         clip;
    AEERect         rect;
    const AECHAR    str[]       = {'B','R','E','W',' ','B','R','E','W',' ','B','R','E','W','\0'};

    // ʂΐFŃNA
    IDISPLAY_SetColor(display,CLR_USER_BACKGROUND,MAKE_RGB(0xCC,0xFF,0xCC));
    IDISPLAY_ClearScreen(display);

    // NbsÖlp`ɐݒ
    clip.x = 20;
    clip.y = 20;
    clip.dx = 80;
    clip.dy = 80;
    IDISPLAY_SetClipRect(display,&clip);

    // `FԐFŎlp``
    rect.x = 10;
    rect.y = 10;
    rect.dx = 60;
    rect.dy = 50;
    IDISPLAY_DrawRect(display,&rect,MAKE_RGB(0xFF,0x88,0x88),MAKE_RGB(0xFF,0xCC,0xCC),IDF_RECT_FRAME | IDF_RECT_FILL);

    // FFɐݒ
    IDISPLAY_SetColor(display,CLR_USER_TEXT,MAKE_RGB(0x00,0x00,0x00));

    // `
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str,-1,0,55,NULL,IDF_TEXT_TRANSPARENT);
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str,-1,20,70,NULL,IDF_TEXT_TRANSPARENT);

    // NbsÖZbg
    IDISPLAY_SetClipRect(display,NULL);

    // ʍXV
    IDISPLAY_Update(display);
    return;
}

//
//  IGraphics C^[tF[X IDisplay C^[tF[X
//  gpċ`̈NbsOĕ`悷֐
//
static void Graphix_UseIGraphicsAndIDisplay(GraphixApplet* app)
{
    IGraphics*      graphics    = app->g;
    IShell*         shell       = app->a.m_pIShell;
    IDisplay*       display     = app->a.m_pIDisplay;
    IBitmap*        bmp;
    AEEClip         clip;
    AEECircle       circle;
    const AECHAR    str[]       = {'B','R','E','W',' ','B','R','E','W',' ','B','R','E','W','\0'};

    // ʂΐFŃNA
    IGRAPHICS_SetBackground(graphics,0xCC,0xFF,0xCC);
    IGRAPHICS_ClearViewport(graphics);

    // NbsÖlp`ɐݒ
    clip.type = CLIPPING_RECT;
    clip.shape.rect.x = 20;
    clip.shape.rect.y = 20;
    clip.shape.rect.dx = 80;
    clip.shape.rect.dy = 80;
    IGRAPHICS_SetClip(graphics,&clip,0);
    IDISPLAY_SetClipRect(display,&clip.shape.rect);

    // \[X t@Crbg}bv擾
    bmp = ISHELL_LoadResBitmap(shell,GRAPHIX_RES_FILE,TILE);
    if (bmp != NULL) {

        // rbg}bv`
        IDISPLAY_BitBlt(display,0,0,100,100,bmp,0,0,AEE_RO_COPY);

        // rbg}bvj
        IBITMAP_Release(bmp);
    }

    // hׂ[hݒ
    IGRAPHICS_SetFillMode(graphics,TRUE);

    // `FFɐݒ
    IGRAPHICS_SetColor(graphics,0x88,0x88,0xFF,0x00);
    IGRAPHICS_SetFillColor(graphics,0xCC,0xCC,0xFF,0x00);

    // ~`
    circle.cx = 80;
    circle.cy = 70;
    circle.r = 40;
    IGRAPHICS_DrawCircle(graphics,&circle);

    // FFɐݒ
    IDISPLAY_SetColor(display,CLR_USER_TEXT,MAKE_RGB(0x00,0x00,0x00));

    // `
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str,-1,0,55,NULL,IDF_TEXT_TRANSPARENT);
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str,-1,20,70,NULL,IDF_TEXT_TRANSPARENT);

    // NbsÖZbg
    IGRAPHICS_SetClip(graphics,NULL,0);
    IDISPLAY_SetClipRect(display,NULL);

    // ʍXV
    IGRAPHICS_Update(graphics);
    IDISPLAY_Update(display);
    return;
}

//
//  IGraphics C^[tF[X̃gX[g
//  gpĕ`悷֐
//
static void Graphix_TranslateUseIGraphics(GraphixApplet* app)
{
    IGraphics*      graphics    = app->g;
    AEERect         rect;

    // ʂΐFŃNA
    IGRAPHICS_SetBackground(graphics,0xCC,0xFF,0xCC);
    IGRAPHICS_ClearViewport(graphics);

    // hׂ[hݒ
    IGRAPHICS_SetFillMode(graphics,TRUE);

    // `FԐFɐݒ
    IGRAPHICS_SetColor(graphics,0xFF,0x88,0x88,0x00);
    IGRAPHICS_SetFillColor(graphics,0xFF,0xCC,0xCC,0x00);

    // lp``
    rect.x = 10;
    rect.y = 10;
    rect.dx = 60;
    rect.dy = 50;
    IGRAPHICS_DrawRect(graphics,&rect);

    // gX[gʂݒ
    IGRAPHICS_Translate(graphics,-40,-40);

    // `FFɐݒ
    IGRAPHICS_SetColor(graphics,0x88,0x88,0xFF,0x00);
    IGRAPHICS_SetFillColor(graphics,0xCC,0xCC,0xFF,0x00);

    // lp``
    IGRAPHICS_DrawRect(graphics,&rect);

    // gX[gZbg
    IGRAPHICS_Translate(graphics,40,40);

    // ʍXV
    IGRAPHICS_Update(graphics);
    return;
}

//
//  TransformBltSimple ֐gpărbg}bv
//  ό`]֐
//
static void Graphix_TransformSimple(GraphixApplet* app)
{
    IShell*         shell       = app->a.m_pIShell;
    IDisplay*       display     = app->a.m_pIDisplay;
    IBitmap*        dev;
    IBitmap*        tmp;
    IBitmap*        bmp;
    ITransform*     transform;

    // ʂΐFŃNA
    IDISPLAY_SetColor(display,CLR_USER_BACKGROUND,MAKE_RGB(0xCC,0xFF,0xCC));
    IDISPLAY_ClearScreen(display);

    // foCX̃rbg}bv擾
    IDISPLAY_GetDeviceBitmap(display,&dev);

    // foCXrbg}bvƌ݊̂Ɨprbg}bv쐬
    IBITMAP_CreateCompatibleBitmap(dev,&tmp,100,100);

    // \[X t@Crbg}bv擾
    bmp = ISHELL_LoadResBitmap(shell,GRAPHIX_RES_FILE,TILE);
    if (bmp != NULL) {

        // Ɨprbg}bvɃrbg}bv`
        IBITMAP_BltIn(tmp,0,0,100,100,bmp,0,0,AEE_RO_COPY);

        // foCXrbg}bv ITransform C^[tF[X쐬
        IBITMAP_QueryInterface(dev,AEECLSID_TRANSFORM,&transform);

        // Ɨprbg}bvfoCXrbg}bv֕ό`]
        ITRANSFORM_TransformBltSimple(transform,          // IuWFNg
                                      0,                  // ] X W
                                      0,                  // ] Y W
                                      tmp,                // ]̃rbg}bv
                                      0,                  // ]̓]Jn X W
                                      0,                  // ]̓]Jn Y W
                                      100,                // ]̕
                                      100,                // ]̍
                                      TRANSFORM_ROTATE_90 | TRANSFORM_SCALE_2,   // ό`@
                                      COMPOSITE_OPAQUE);  // ][h

        // ITransform C^[tF[Xj
        ITRANSFORM_Release(transform);

        // rbg}bvj
        IBITMAP_Release(bmp);
    }

    // ʍXV
    IDISPLAY_Update(display);

    // Ɨprbg}bvj
    IBITMAP_Release(tmp);

    // foCXrbg}bvj
    IBITMAP_Release(dev);
    return;
}

//
//  TransformBltComplex ֐gpărbg}bv
//  ό`]֐
//
static void Graphix_TransformComplex(GraphixApplet* app)
{
    IShell*             shell   = app->a.m_pIShell;
    IDisplay*           display = app->a.m_pIDisplay;
    IBitmap*            dev;
    IBitmap*            tmp;
    IBitmap*            bmp;
    ITransform*         transform;
    AEETransformMatrix  matrix;

    // ʂΐFŃNA
    IDISPLAY_SetColor(display,CLR_USER_BACKGROUND,MAKE_RGB(0xCC,0xFF,0xCC));
    IDISPLAY_ClearScreen(display);

    // foCX̃rbg}bv擾
    IDISPLAY_GetDeviceBitmap(display,&dev);

    // foCXrbg}bvƌ݊̂Ɨprbg}bv쐬
    IBITMAP_CreateCompatibleBitmap(dev,&tmp,100,100);

    // \[X t@Crbg}bv擾
    bmp = ISHELL_LoadResBitmap(shell,GRAPHIX_RES_FILE,TILE);
    if (bmp != NULL) {

        // Ɨprbg}bvɃrbg}bv`
        IBITMAP_BltIn(tmp,0,0,100,100,bmp,0,0,AEE_RO_COPY);

        // foCXrbg}bv ITransform C^[tF[X쐬
        IBITMAP_QueryInterface(dev,AEECLSID_TRANSFORM,&transform);

        // ό`}gbNXݒ
        matrix.A = 192;   // 256 * 1.5 * cos(60)
        matrix.B = 332;   // 256 * 1.5 * sin(60)
        matrix.C = -332;  // 256 * 1.5 * -sin(60)
        matrix.D = 192;   // 256 * 1.5 * cos(60)

        // Ɨprbg}bvfoCXrbg}bv֕ό`]
        ITRANSFORM_TransformBltComplex(transform,         // IuWFNg
                                       0,                 // ] X W
                                       0,                 // ] Y W
                                       tmp,               // ]̃rbg}bv
                                       0,                 // ]̓]Jn X W
                                       0,                 // ]̓]Jn Y W
                                       100,               // ]̕
                                       100,               // ]̍
                                       &matrix,           // ό`}gbNX
                                       COMPOSITE_OPAQUE); // ][h

        // ITransform C^[tF[Xj
        ITRANSFORM_Release(transform);

        // rbg}bvj
        IBITMAP_Release(bmp);
    }

    // ʍXV
    IDISPLAY_Update(display);

    // Ɨprbg}bvj
    IBITMAP_Release(tmp);

    // foCXrbg}bvj
    IBITMAP_Release(dev);
    return;
}

//
//  ʂԂɖ߂֐
//
static void Graphix_ClearScreen(GraphixApplet* app)
{
    const AECHAR    str0[]      = {'0',':','C','l','e','a','r',' ','s','c','r','e','e','n','\0'};
    const AECHAR    str1[]      = {'1',':','C','l','i','p',' ','r','e','c','t',' ','I','G','\0'};
    const AECHAR    str2[]      = {'2',':','C','l','i','p',' ','c','i','r','c','l','e',' ','I','G','\0'};
    const AECHAR    str3[]      = {'3',':','C','l','i','p',' ','r','e','c','t',' ','I','D','\0'};
    const AECHAR    str4[]      = {'4',':','I','G',' ','a','n','d',' ','I','D','\0'};
    const AECHAR    str5[]      = {'5',':','T','r','a','n','s','l','a','t','e',' ','I','G','\0'};
    const AECHAR    str6[]      = {'6',':','X','f','o','r','m',' ','S','i','m','p','l','e','\0'};
    const AECHAR    str7[]      = {'7',':','X','f','o','r','m',' ','C','o','m','p','l','e','x','\0'};
    IShell*         shell       = app->a.m_pIShell;
    IDisplay*       display     = app->a.m_pIDisplay;
    AEERect         rect;
    AEEDeviceInfo   info;

    // foCX擾
    ISHELL_GetDeviceInfo(shell,&info);

    // `悷`ݒ
    rect.x = 0;
    rect.y = 0;
    rect.dx = info.cxScreen;
    rect.dy = IDISPLAY_GetFontMetrics(display,AEE_FONT_NORMAL,NULL,NULL);

    // ʂNA
    IDISPLAY_SetColor(display,CLR_USER_BACKGROUND,MAKE_RGB(0xFF,0xFF,0xFF));
    IDISPLAY_ClearScreen(display);

    // `
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str0,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str1,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str2,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str3,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str4,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str5,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str6,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);
    rect.y += rect.dy;
    IDISPLAY_DrawText(display,AEE_FONT_NORMAL,str7,-1,0,0,&rect,IDF_ALIGN_LEFT | IDF_ALIGN_MIDDLE);

    // ʍXV
    IDISPLAY_Update(display);
    return;
}
